"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }// src/index.ts
var _crypto = require('crypto'); var _crypto2 = _interopRequireDefault(_crypto);
function pbkdf2({ password, salt }) {
  return new Promise((resolve, reject) => {
    _crypto.pbkdf2.call(void 0, password, salt, 1, 64, "sha256", (error, key) => {
      if (error)
        return reject(error);
      resolve(key);
    });
  });
}
function generateRandom() {
  return Buffer.from(_crypto2.default.randomBytes(16));
}
async function aesEncrypt(data, password) {
  const salt = generateRandom();
  const iv = generateRandom();
  const key = await pbkdf2({ password, salt });
  const encryptTool = _crypto2.default.createCipheriv(
    "aes-256-cbc",
    key.subarray(0, 32),
    iv
  );
  let encryptedContent = encryptTool.update(data, "utf8", "base64");
  encryptedContent += encryptTool.final("base64");
  console.log(encryptedContent);
  const packaged = Buffer.concat([
    iv,
    salt,
    Buffer.from(encryptedContent, "base64")
  ]);
  return packaged.toString("base64");
}
async function aesDecrypt(data, password) {
  const unpackaged = Buffer.from(data, "base64");
  const iv = unpackaged.subarray(0, 16);
  const salt = unpackaged.subarray(16, 32);
  const input = unpackaged.subarray(32);
  const key = await pbkdf2({ password, salt });
  const decryptTool = _crypto2.default.createDecipheriv(
    "aes-256-cbc",
    key.subarray(0, 32),
    iv
  );
  decryptTool.update(
    input.toString("base64"),
    "base64",
    "utf8"
  );
  return decryptTool.final("utf8");
}




exports.aesDecrypt = aesDecrypt; exports.aesEncrypt = aesEncrypt; exports.pbkdf2 = pbkdf2;
